stages:
  - build
  - test
  - publish
  - deploy

# ---------------------- BUILD ---------------------- 

dailyplan_service_build:
  stage: build
  script:
    - . scripts/build.sh dailyplan_service backend/WebServices/DailyPlanWebService backend/
  tags:
    - education

epictask_service_build:
  stage: build
  script:
    - . scripts/build.sh epictask_service backend/WebServices/EpicTaskWebService backend/
  tags:
    - education 

job_service_build:
  stage: build
  script:
    - . scripts/build.sh job_service backend/WebServices/JobWebService backend/
  tags:
    - education     

user_service_build:
  stage: build
  script:
    - . scripts/build.sh user_service backend/WebServices/UserWebService backend/
  tags:
    - education

reverse_proxy_build:
  stage: build
  script:
    - . scripts/build.sh reverse_proxy backend/ReverseProxy backend/
  tags:
    - education 

frontend_build:
  stage: build
  script:
    - . scripts/build.sh frontend frontend frontend/
  tags:
    - education 

# ----------------------- TEST  ----------------------- 
    
dailyplan_service_tests:
  stage: test
  script:
    - . ./scripts/build.sh dailyplan_service_tests backend/Tests/DailyPlanWebService.Test backend/
    - . ./scripts/run.sh dailyplan_service_tests
  tags:
    - education 

epictask_service_tests:
  stage: test
  script:
    - . ./scripts/build.sh epictask_service_tests backend/Tests/EpicTaskWebService.Test backend/
    - . ./scripts/run.sh epictask_service_tests
  tags:
    - education 

job_service_tests:
  stage: test
  script:
    - . ./scripts/build.sh job_service_tests backend/Tests/JobWebService.Test backend/
    - . ./scripts/run.sh job_service_tests
  tags:
    - education 

user_service_tests:
  stage: test
  script:
    - . ./scripts/build.sh user_service_tests backend/Tests/UserWebService.Test backend/
    - . ./scripts/run.sh user_service_tests
  tags:
    - education 

reverse_proxy_tests:
  stage: test
  script:
    - . ./scripts/build.sh reverse_proxy_tests backend/Tests/ReverseProxy.Test backend/
    - . ./scripts/run.sh reverse_proxy_tests
  tags:
    - education     

    
# ----------------------- PUBLISH  ----------------------- 

dailyPlan_service_publish:
  stage: publish
  script:
    - docker login -u $REGISTRY_LOGIN -p $REGISTRY_PASSWORD
    - . scripts/publish.sh dailyplan_service
  tags:
    - education
    
epicTask_service_publish:
  stage: publish
  script:
    - docker login -u $REGISTRY_LOGIN -p $REGISTRY_PASSWORD
    - . scripts/publish.sh epictask_service
  tags:
    - education
    
job_service_publish:
  stage: publish
  script:
    - docker login -u $REGISTRY_LOGIN -p $REGISTRY_PASSWORD
    - . scripts/publish.sh job_service
  tags:
    - education
    
user_service_publish:
  stage: publish
  script:
    - docker login -u $REGISTRY_LOGIN -p $REGISTRY_PASSWORD
    - . scripts/publish.sh user_service
  tags:
    - education
    
reverse_proxy_publish:
  stage: publish
  script:
    - docker login -u $REGISTRY_LOGIN -p $REGISTRY_PASSWORD
    - . scripts/publish.sh reverse_proxy
  tags:
    - education
    
frontend_publish:
  stage: publish
  script:
    - docker login -u $REGISTRY_LOGIN -p $REGISTRY_PASSWORD
    - . scripts/publish.sh frontend
  tags:
    - education


# ----------------------- DEPLOY  ----------------------- 

deploy_stack_prod:
  stage: deploy
  environment:
    name: $CI_COMMIT_REF_NAME
  only: 
    - master
  script:
    - . scripts/deploy.sh
  tags:
    - education
    
deploy_stack_dev:
    stage: deploy
    environment:
      name: $CI_COMMIT_REF_NAME
    except:
      - master
    when: manual
    script:
      - . scripts/deploy.sh
    tags:
      - education
